commit 4d8f72b510bf12a5ac7dc5cfa642640d5d0fa0ed
Author: Christophe Lyon <christophe.lyon@linaro.org>
Date:   Wed Nov 26 14:03:37 2025

    arm: Fix constraints in MVE asrl and lsll patterns [PR122858]
    
    The second alternative for operand 1 needs a new constraint which does
    not overlap with Pg, except that it can handle 32 to generate an
    optimal mov.
    
    This patch introduces a new Ph constraint which has the [32..255]
    range.
    
    This fixes a lot of regressions when running the testsuite for an MVE
    target such as -march=armv8.1-m.main+mve.fp+fp.dp -mfloat-abi=hard.
    
    gcc/ChangeLog:
    
            PR target/122858
            * config/arm/constraints.md (Ph): New constraint.
            * config/arm/mve.md (mve_asrl_imm, mve_lsll_imm): Fix constraints
            of operand 1 and handle 32 as special shift amount.
    
    gcc/testsuite/ChangeLog:
    
            PR target/122858
            * gcc.target/arm/mve/pr122858.c: New test.
    
    (cherry picked from commit cf78d402655d5fc9cb8780cb8837889afbe17ff6)

diff --git a/gcc/testsuite/gcc.target/arm/mve/pr122858.c b/gcc/testsuite/gcc.target/arm/mve/pr122858.c
new file mode 100644
index 00000000000..3e6d29d9ce6
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/mve/pr122858.c
@@ -0,0 +1,83 @@
+/* { dg-do run } */
+/* { dg-require-effective-target arm_mve_hw } */
+/* { dg-options "-O2" } */
+/* { dg-add-options arm_v8_1m_mve } */
+/* { dg-final { check-function-bodies "**" "" "" } } */
+
+extern void abort (void);
+
+/*
+** ashrl_fn:
+**...
+**	asrl	r[0-9]+, r[0-9]+, #31
+**...
+*/
+__attribute__ ((noipa))
+long long ashrl_fn (long long a)
+{
+  long long c;
+
+  c = a >> 31;
+  c += a;
+  return c;
+}
+
+/*
+** ashll_fn:
+**...
+**	add	(r[0-9]+), \1, r[0-9]+, lsl #2
+**...
+*/
+__attribute__ ((noipa))
+long long ashll_fn (long long a)
+{
+  long long c;
+
+  /* Use 34, since 33 causes PR122871.  */
+  c = a << 34;
+  c += a;
+  return c;
+}
+
+/*
+** ashll_fn2:
+**...
+**	lsll	r[0-9]+, r[0-9]+, #7
+**...
+*/
+__attribute__ ((noipa))
+long long ashll_fn2 (long long a /* unused */, long long x)
+{
+  return x << 7;
+}
+
+/*
+** ashll_fn3:
+**...
+**	lsls	r[0-9]+, (r[0-9]+), #2
+**	movs	\1, #0
+**...
+*/
+__attribute__ ((noipa))
+long long ashll_fn3 (long long x)
+{
+  return x << 34;
+}
+
+int main(void)
+{
+  long long var1 = 1;
+  long long var2 = ashll_fn (var1);
+  if (var2 != 0x400000001)
+    abort ();
+
+  var2 = ashrl_fn (var2);
+  if (var2 != 0x400000009)
+    abort ();
+
+  var2 = ashll_fn2 (var2, 0xa987654350000002LL);
+  if (var2 != 0xc3b2a1a800000100LL)
+    abort ();
+
+  return 0;
+}

